/* ### CHECK-ME-BEFORE-RELEASE ### */
/*
 * Title:   pimath.c
 * Created: Thu May 18 00:17:06 2000
 * Authors: Gilbert Baumann, Markus Noga, Tim Weyrich
 *     $Id: pimath.c,v 1.4 2003/11/19 10:37:30 weyrich Exp $
 *
 * Copyright (c) 2000--2003
 * Gilbert Baumann <unk6@stud.uni-karlsruhe.de>
 * Markus Noga <markus@noga.de>
 * Tim Weyrich <weyrich@inf.ethz.ch>
 *
 * This file is part of the Pointshop3D system.
 * See http: *www.pointshop3d.com/ for more information.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 * Contact info@pointshop3d.com if any conditions of this
 * licensing are not clear to you.
 *
 * ---------------------------------------------------------------
 *
 * $Log: pimath.c,v $
 * Revision 1.4  2003/11/19 10:37:30  weyrich
 * added Pointshop3D headers
 *
 * Revision 1.3  2003/06/23 14:14:39  weyrich
 * more Win32 port...
 *
 * Revision 1.2  2002/01/15 14:24:54  weyrich
 * some IEEE-float cosmetics...
 *
 * Revision 1.1.1.2  2001/11/18 20:14:12  weyrich
 * first check-in
 *
 * Revision 1.2  2000/06/22 01:14:27  mlnoga
 * first version of low-level sound driver; portability adaptions
 *
 * Revision 1.1  2000/05/17 22:11:28  tim
 * added pimath.[ch]
 *
 */

#include "pimath.h"

/* This ifdef should become `#ifdef HAVE_BINDING_TO_LIBRARY_WITH_RINT'.
 */
#if defined(_WIN32)
double rint(double x)
{
  return floor(x+0.5);
}

/*extern int _finite(double);*/

int isinf(double x)
{
  return !_finite(x);
}

#endif

int pi_isnan(double x)
{
  return  (((*(int *)&x)&(255<<23))==(255<<23));
}

double pi_rint(double x)
{
  return floor(x+0.5);
}
