/* ### CHECK-ME-BEFORE-RELEASE ### */
/*
 * Title:   pistring.c
 * Created: Wed May 17 23:15:53 2000
 * Authors: Gilbert Baumann, Markus Noga, Tim Weyrich
 *     $Id: pistring.c,v 1.5 2003/12/30 20:24:09 weyrich Exp $
 *
 * Copyright (c) 2000--2003
 * Gilbert Baumann <unk6@stud.uni-karlsruhe.de>
 * Markus Noga <markus@noga.de>
 * Tim Weyrich <weyrich@inf.ethz.ch>
 *
 * This file is part of the Pointshop3D system.
 * See http: *www.pointshop3d.com/ for more information.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 * Contact info@pointshop3d.com if any conditions of this
 * licensing are not clear to you.
 *
 * ---------------------------------------------------------------
 *
 * $Log: pistring.c,v $
 * Revision 1.5  2003/12/30 20:24:09  weyrich
 * last commit before continuing at MERL
 *
 * Revision 1.4  2003/11/19 10:37:30  weyrich
 * added Pointshop3D headers
 *
 * Revision 1.3  2003/11/14 17:15:09  weyrich
 * another Win32 fix
 *
 * Revision 1.2  2002/05/23 14:02:33  weyrich
 * First official libsfl release.
 *
 * Revision 1.1.1.2  2001/11/18 20:14:13  weyrich
 * first check-in
 *
 * Revision 1.1  2000/05/17 20:36:19  tim
 * added pistring.[ch]
 *
 */

#include "pisystem.h"
#include "pistring.h"

/* This ifdef should become `#ifdef HAVE_BINDING_TO_LIBRARY_WITH_STRDUP'.
 */
#if defined(__STRICT_ANSI__) && !defined(_WIN32)

char *strdup(const char *s) __PI_THROW
{
  size_t len = strlen(s)+1;
  char *result = malloc(len);
  if (result)
    memcpy(result,s,len);
  return result;
}

char *strndup(const char *s, size_t size) __PI_THROW
{
  int   i;
  char *result;
  for (i=0; s[i] && i < size; i++);
  result = malloc(i+1);
  if (result)
    {
      memcpy(result,s,i);
      result[i] = 0;
    }
  return result;
}

#endif
